//----------------------------------------------------------------------------
// VolumeSlider_MainWnd.cpp : ʐݒpXC_̊Ǘs
//----------------------------------------------------------------------------
#include <windows.h>
#include "../Common/Utils.h"
#include "../App.h"
#include "MainWnd.h"
#include "VolumeSlider_MainWnd.h"
//----------------------------------------------------------------------------
// 쐬
//----------------------------------------------------------------------------
BOOL CVolumeSlider_MainWnd::Create()
{
	CSliderCtrl::Create(m_rMainWnd);
	if(!m_hWnd) return FALSE;

	SetStyle(GetStyle() | WS_TABSTOP | TBS_AUTOTICKS | TBS_HORZ | TBS_NOTICKS);
	ResetPos();
	ResetSize();

	SetRangeMin(0);
	SetRangeMax(1000);
	SetLineSize(10);
	SetPageSize(50);
	SetThumbPos(1000);

	return TRUE;
}
//----------------------------------------------------------------------------
// 𓾂
//----------------------------------------------------------------------------
int CVolumeSlider_MainWnd::GetHeight() const
{
	if(m_rMainWnd.GetMenu().IsItemChecked(ID_VOLUME))
		return CSliderCtrl::GetHeight();
	else return m_rMainWnd.GetDivider3().GetHeight();
}
//----------------------------------------------------------------------------
// cʒu𓾂
//----------------------------------------------------------------------------
int CVolumeSlider_MainWnd::GetTop() const
{
	if(m_rMainWnd.GetMenu().IsItemChecked(ID_VOLUME))
		return CSliderCtrl::GetTop();
	else return m_rMainWnd.GetDivider3().GetTop();
}
//----------------------------------------------------------------------------
// ʒu̍Đݒ
//----------------------------------------------------------------------------
void CVolumeSlider_MainWnd::ResetPos()
{
	POINT pt;
	pt.x = m_rMainWnd.GetVolumeLabel().GetLeft();
	pt.y = m_rMainWnd.GetVolumeLabel().GetTop();
	ScreenToClient(m_rMainWnd, &pt);
	int nLeft = pt.x + m_rMainWnd.GetVolumeLabel().GetWidth() + m_rMainWnd.GetControlOffset();
	SetPos(nLeft, pt.y);
}
//----------------------------------------------------------------------------
// TCY̍Đݒ
//----------------------------------------------------------------------------
void CVolumeSlider_MainWnd::ResetSize()
{
	POINT pt;
	pt.x = GetLeft();
	ScreenToClient(m_rMainWnd, &pt);
	int nWidth = m_rMainWnd.GetClientWidth() - pt.x;
	SetSize(nWidth, (int)(GetSystemMetrics(SM_CYHSCROLL) * 1.5));
}
//----------------------------------------------------------------------------
// R}h
//----------------------------------------------------------------------------
void CVolumeSlider_MainWnd::OnCommand(int id, HWND hwndCtl, UINT codeNotify)
{
	if(!hwndCtl) m_rClickMenu.OnCommand(id, hwndCtl, codeNotify);
	CSliderCtrl::OnCommand(id, hwndCtl, codeNotify);
}
//----------------------------------------------------------------------------
// XN[ꂽ
//----------------------------------------------------------------------------
void CVolumeSlider_MainWnd::OnHScroll(HWND hwndCtl, UINT code, int pos)
{
	double n = (double)(GetThumbPos() / 10.0);
	LONG trackpos = GetThumbPos();
	m_rMainWnd.SetVolume(n);
	m_rMainWnd.GetVolumeLabel().SetVolume(n);
}
//----------------------------------------------------------------------------
// L[{[hꂽ
//----------------------------------------------------------------------------
void CVolumeSlider_MainWnd::OnKeyDown(UINT vk, int cRepeat, UINT flags)
{
	if(vk == VK_TAB) {
		if(GetKeyState(VK_CONTROL) < 0)
			m_rMainWnd.SetFocusNextTab();
		else
			m_rMainWnd.SetFocusNextControl();
	}
	else if(vk == VK_HOME) {
		SetThumbPos(1000);
		m_rMainWnd.SetVolume(100.0);
		m_rMainWnd.GetVolumeLabel().SetVolume(100.0);
		return;
	}
	else if(vk == VK_UP) vk = VK_DOWN;
	else if(vk == VK_DOWN) vk = VK_UP;
	else if(vk == VK_PRIOR) vk = VK_NEXT;
	else if(vk == VK_NEXT) vk = VK_PRIOR;
	CSliderCtrl::OnKeyDown(vk, cRepeat, flags);
}
//----------------------------------------------------------------------------
// NbNꂽ
//----------------------------------------------------------------------------
void CVolumeSlider_MainWnd::OnLButtonDown(int x, int y, UINT keyFlags)
{
	RECT rc;
	SendMessage(m_hWnd, TBM_GETTHUMBRECT, 0, (LPARAM)&rc);
	if(rc.left < x && x < rc.right &&
		rc.top < y && y < rc.bottom) {
		if(GetTickCount() - dwThumbClickTime <= GetDoubleClickTime()) {
			SetThumbPos(1000);
			m_rMainWnd.GetVolumeLabel().SetVolume(100.0);
			m_rMainWnd.SetVolume(100.0);
			return;
		}
		else dwThumbClickTime = GetTickCount();
	}
	CSliderCtrl::OnLButtonDown(x, y, keyFlags);
}
//----------------------------------------------------------------------------
// }EXzC[XN[ꂽ
//----------------------------------------------------------------------------
BOOL CVolumeSlider_MainWnd::OnMouseWheel(UINT nFlags, int zDelta, POINTS pt)
{
	tstring strVol = m_rMainWnd.GetVolumeLabel().GetEdit().GetText();
	int n = _ttoi(CUtils::Replace(strVol, _T("."), _T("")).c_str());
	if(zDelta >= 0) n++;
	else n--;
	int nMin = GetRangeMin(), nMax = GetRangeMax();
	if(n < nMin) n = nMin;
	if(n > nMax) n = nMax;
	double dVol = n / 10.0;
	m_rMainWnd.SetVolume(dVol);
	m_rMainWnd.GetVolumeLabel().SetVolume(dVol);
	return FALSE;
}
//----------------------------------------------------------------------------
// ENbNꂽ
//----------------------------------------------------------------------------
void CVolumeSlider_MainWnd::OnRButtonUp(int x, int y, UINT keyFlags)
{
	m_rClickMenu.Create();
	POINT pt;
	GetCursorPos(&pt);
	SetForegroundWindow(m_hWnd);
	TrackPopupMenu((HMENU)m_rClickMenu, TPM_LEFTALIGN | TPM_TOPALIGN, pt.x,
		pt.y, 0, m_hWnd, NULL);

	CSliderCtrl::OnRButtonUp(x, y, keyFlags);
}
//----------------------------------------------------------------------------
